/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2012,2014 University of Zagreb
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Vedran Miletić <rivanvx@gmail.com>
 */

#ifndef START_STOP_FUNCTIONALITY_H
#define START_STOP_FUNCTIONALITY_H

#include "traced-callback.h"

namespace ns3 {

class StopRestartFunctionality
{
public:
  StopRestartFunctionality ();
  ~StopRestartFunctionality ();

  virtual void Restart (void);
  virtual void Stop (void);
  virtual bool IsStarted (void) const;

protected:
  bool m_started;
  TracedCallback<> m_restartTrace;
  TracedCallback<> m_stopTrace;
};

} // namespace ns3

#endif /* START_STOP_FUNCTIONALITY_H */
