/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2012,2015 University of Zagreb
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Vedran Miletić <rivanvx@gmail.com>
 */

#ifndef STOPPABLE_OBJECT_H
#define STOPPABLE_OBJECT_H

#include "object.h"
#include "stop-restart-functionality.h"

namespace ns3 {

class StoppableObject : public Object, public StopRestartFunctionality
{
public:
  static TypeId GetTypeId (void);

  StoppableObject ();
  virtual ~StoppableObject ();
};

} // namespace ns3

#endif /* STOPPABLE_OBJECT_H */
