/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2012,2014 University of Zagreb
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Author: Vedran Miletić <rivanvx@gmail.com>
 */

#ifndef FAILURE_REPAIR_TIME_TRACKER_CONTAINER
#define FAILURE_REPAIR_TIME_TRACKER_CONTAINER

#include <ns3/ptr.h>

#include <stdint.h>
#include <vector>

namespace ns3 {
  
class FailureRepairTimeTracker;

/**
 * FIXME
 */
class FailureRepairTimeTrackerContainer
{
public:
  typedef std::vector<Ptr<FailureRepairTimeTracker> >::const_iterator Iterator;

  /**
   * FIXME
   */
  FailureRepairTimeTrackerContainer ();

  /**
   * FIXME
   */
  FailureRepairTimeTrackerContainer (Ptr<FailureRepairTimeTracker> fwtt);

  /**
   * FIXME
   */
  FailureRepairTimeTrackerContainer (const FailureRepairTimeTrackerContainer &a, const FailureRepairTimeTrackerContainer &b);

  /**
   * FIXME
   */
  Iterator Begin (void) const;

  /**
   * FIXME
   */
  Iterator End (void) const;

  /**
   * FIXME
   */
  uint32_t GetN (void) const;

  /**
   * FIXME
   */
  Ptr<FailureRepairTimeTracker> Get (uint32_t i) const;
  
  /**
   * FIXME
   */
  void Create (uint32_t n);

  /**
   * FIXME
   */
  void Add (FailureRepairTimeTrackerContainer other);

  /**
   * FIXME
   */
  void Add (Ptr<FailureRepairTimeTracker> fwtt);

private:
  std::vector<Ptr<FailureRepairTimeTracker> > m_failedWorkingTimeTrackers;
};

} // namespace ns3

#endif /* FAILURE_REPAIR_TIME_TRACKER_CONTAINER */
